﻿@model CollectionViewModel

@{
    ViewData["Title"] = "Index";
}

@*<script src="~/Scripts/jquery-1.10.2.min.js"></script>
<link rel="stylesheet" href="//code.jquery.com/ui/1.12.1/themes/base/jquery-ui.css">
<script src="https://code.jquery.com/ui/1.12.1/jquery-ui.js"></script>

<script>
    $("#searchInput").autocomplete({
        source: function (request, response) {
            $.ajax({
                url: '@Url.Action("GetSearchValue","Books")',
                dataType: "json",
                data: { search: $("#searchInput").val() },
                success: function (data) {
                    response($.map(data, function (item) {
                        return { label: item.Name, value: item.Name };
                    }));
                },
                error: function (xhr, status, error) {
                    alert("Error");
                }
            });
        }
    });
</script>*@
<div id="login" class="media">
    <div class="media-body">
        <h1 class="mt-0 mb-1 text">Catalog</h1>
    </div>
</div>
<hr class="bg-dark" />
<form asp-action="Index" method="get">
    <div class="form-actions no-color">
        <p id="login">
            Find by name: <input type="text" name="SearchString" value="@ViewData["currentFilter"]" />
            <button type="submit" class="btn btn-secondary bg-transparent border-0">
                <img class="d-flex ml-3" src="~/lib/images/SearchGreenTrans.png" alt="Details" width="100">
            </button>
            <a asp-action="Index">
                <img src="~/lib/images/BackToListRedTrans.png" alt="BackToList" width="100">
            </a>
        </p>
    </div>
</form>
<table class="table table-hover text-decoration-none" id="login">
    <thead class="thead-light text-decoration-none text-white">
        <tr>
            <th>
                <a id="login" asp-action="Index" asp-route-sortOrder="@ViewData["NameSortParam"]">
                    @Html.DisplayNameFor(model => model.Books.First().Title)
                    <img src="~/lib/images/baseline_swap_vert_black_18dp.png" alt="swap-vert" height="20">
                </a>
            </th>
            <th>
                <a id="login" asp-action="Index" asp-route-sortOrder="@ViewData["DateSortParam"]">
                    @Html.DisplayNameFor(model => model.Books.First().Year)
                    <img src="~/lib/images/baseline_swap_vert_black_18dp.png" alt="swap-vert" height="20">
                </a>
            </th>
            <th>
                <a id="login" asp-action="Index" asp-route-sortOrder="@ViewData["AuthorSortParam"]">
                    @Html.DisplayNameFor(model => model.Books.First().AuthorsNames)
                    <img src="~/lib/images/baseline_swap_vert_black_18dp.png" alt="swap-vert" height="20">
                </a>
            </th>
            <th>
                <a id="login" asp-action="Index" asp-route-sortOrder="@ViewData["StatusSortParam"]">
                    @Html.DisplayNameFor(model => model.Books.First().Status)
                    <img src="~/lib/images/baseline_swap_vert_black_18dp.png" alt="swap-vert" height="20">
                </a>
            </th>
            <th>
                <a id="login" asp-action="Index" asp-route-sortOrder="@ViewData["RatingSortParam"]">
                    @Html.DisplayNameFor(model => model.Books.First().Rating)
                    <img src="~/lib/images/baseline_swap_vert_black_18dp.png" alt="swap-vert" height="20">
                </a>
            </th>
            <th></th>
        </tr>
    </thead>
    <tbody class="table-hover">
        @foreach (var item in Model.Books)
        {
            <tr>
                <td>
                    @Html.DisplayFor(modelItem => item.Title)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Year)
                </td>
                <td>
                    @foreach (var author in item.AuthorsNames)
                    {
                        @Html.DisplayFor(modelItem => author)
                        <br />
                    }
                </td>
                <td>
                    @if (item.Status == "Available")
                    {
                        <span class="text-success">@Html.DisplayFor(modelItem => item.Status)</span>
                    }
                    else if (item.Status == "Taken")
                    {
                        <span class="text-danger">@Html.DisplayFor(modelItem => item.Status)</span>
                    }
                    else
                    {
                        <span class="text-warning">@Html.DisplayFor(modelItem => item.Status)</span>
                    }
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Rating)
                </td>

                @if (!this.User.Identity.IsAuthenticated)
                {

                    <td>
                        <div class="btn-group btn-group-sm" role="group" aria-label="Basic example">
                            <button type="button" class="btn btn-secondary bg-transparent border-0">
                                <a asp-action="Details" asp-route-id="@item.Id">
                                    <img class="d-flex ml-3" src="~/lib/images/DetailsYellowTrans.png" alt="Details" width="100">
                                </a>
                            </button>
                        </div>
                    </td>
                }
                else
                {
                    if (this.User.IsBanned())
                    {

                    }
                    else if (this.User.IsInRole("Admin"))
                    {
                        <td>
                            <div class="btn-group btn-group-sm" role="group" aria-label="Basic example">
                                <button type="button" class="btn btn-secondary bg-transparent border-0">
                                    <a asp-action="Edit" asp-route-id="@item.Id">
                                        <img class="d-flex ml-3" src="~/lib/images/EditGreenTrans.png" alt="Edit" width="100">
                                    </a>
                                </button>
                                <button type="button" class="btn btn-secondary bg-transparent border-0">
                                    <a asp-action="Details" asp-route-id="@item.Id">
                                        <img class="d-flex ml-3" src="~/lib/images/DetailsYellowTrans.png" alt="Details" width="100">
                                    </a>
                                </button>
                                <button type="button" class="btn btn-secondary bg-transparent border-0">
                                    <a asp-action="Delete" asp-route-id="@item.Id">
                                        <img class="d-flex ml-3" src="~/lib/images/DeleteRedTrans.png" alt="Delete" width="100">
                                    </a>
                                </button>
                            </div>
                        </td>
                    }
                    else
                    {
                        <td>
                            <div class="btn-group btn-group-sm" role="group" aria-label="Basic example">
                                <a asp-controller="Grades" asp-action="Review" asp-route-id="@item.Id">
                                    <img class="d-flex ml-3" src="~/lib/images/ReviewGreenTrans.png" alt="Review" width="100">
                                </a>
                                <button asp-action="Details" asp-route-id="@item.Id" type="button" class="btn btn-secondary bg-transparent border-0">
                                    <a asp-action="Details" asp-route-id="@item.Id">
                                        <img class="d-flex ml-3" src="~/lib/images/DetailsYellowTrans.png" alt="Details" width="100">
                                    </a>
                                </button>

                                @if (Model.Books.FirstOrDefault(bvm => bvm.UserId == bvm.CurrentUserId &&
                                          bvm.Status == "Taken" &&
                                          bvm.Id == item.Id) != null)
                                {
                                    <button type="button" class="btn btn-secondary bg-transparent border-0">
                                        <a asp-action="Return" asp-route-bookId="@item.Id">
                                            <img class="d-flex ml-3" src="~/lib/images/ReturnRedTrans.png" alt="Return" width="100">
                                        </a>
                                    </button>
                                }
                                else if (Model.Books.FirstOrDefault(bvm => bvm.UserId != bvm.CurrentUserId && bvm.Status == "Taken" && bvm.Id == item.Id) != null)
                                {
                                    <button type="button" class="btn btn-secondary bg-transparent border-0">
                                        <a asp-action="Reserve" asp-route-bookId="@item.Id">
                                            <img class="d-flex ml-3" src="~/lib/images/ReserveRedTrans.png" alt="Reserve" width="100">
                                        </a>
                                    </button>
                                }
                                else if (Model.Books.FirstOrDefault(bvm => bvm.UserId != bvm.CurrentUserId && bvm.Status == "Reserved" && bvm.Id == item.Id) != null)
                                {
                                    <button type="button" class="btn btn-secondary bg-transparent border-0">
                                        <a asp-action="Reserve" asp-route-bookId="@item.Id">
                                            <img class="d-flex ml-3" src="~/lib/images/ReserveRedTrans.png" alt="Reserve" width="100">
                                        </a>
                                    </button>
                                }
                                else
                                {
                                    <button type="button" class="btn bg-transparent transparent-0">
                                        <a asp-action="Checkout" asp-route-bookId="@item.Id">
                                            <img class="d-flex ml-3" src="~/lib/images/CheckoutRedTrans.png" alt="Checkout" width="100">
                                        </a>
                                    </button>
                                }
                            </div>
                        </td>
                    }
                }

            </tr>
        }
    </tbody>
</table>
<hr />
@*<button type="button" class="btn btn-secondary bg-transparent border-0 float-md-right">
        <a asp-action="Create">
            <img class="d-flex ml-3" src="~/lib/images/CreateNew.png" alt="CreateNew" width="150">
        </a>
    </button>*@
@if (!Model.IsSearchApplied)
{
    <nav aria-label="Page navigation example"></nav>
    <ul class="pagination">
        <a asp-controller="Books" asp-action="Index" asp-route-Id="@Model.PreviousPage">
            <button type="submit" class="btn btn-danger">Previous</button>
        </a>
        <a asp-controller="Books" asp-action="Index" asp-route-Id="@Model.NextPage">
            <button type="submit" class="btn btn-danger">Next</button>
        </a>
    </ul>

    <div id="put-reviews-here">
        <button id="review-button" class="btn btn-primary">Reviews</button>
    </div>
}